﻿var autocompleteCnpj;
var dropdownPart;

/*!
 * Immediately Invoked Function Expression Boilerplate
 * (c) 2019 Chris Ferdinandi, MIT License, https://gomakethings.com
 */
; (function () {
    'use strict';
    var dialogObj;
    var tabObj;
    var empresaDataManager, cfopDataManager;
    var dropdownEmpresaObj, dropdownObjEst, dropdownObjDrop, dropdownTipoAnalise, dropdownCfop;
    var dtPickerInicio, dtPickerInicioSaida, dtPickerFim, dtPickerFimSaida;
    var dateEntradaSliderObj, dateSaidaSliderObj;
    var formObject;
    var isListBoxValid;

    var addButton, removeButton;
    var tiposAnalise = [
        { tipo: 'Isenção Direto', id: '1' },
        { tipo: 'Isenção Intermediário', id: '2' },
        { tipo: 'Venda Equiparada', id: '3' },
        { tipo: 'Estudo Vendas Nacionais', id: '4' }
    ];


    var dataManager = new ej.data.DataManager({
        url: location.origin + '/api/Analise/GetAnalises',
        insertUrl: location.origin + '/api/Analise/SaveAnalise',
        updateUrl: location.origin + '/api/Analise/SaveAnalise',
        removeUrl: location.origin + '/api/Analise/DeleteAnalise',
        adaptor: new ej.data.UrlAdaptor(),
        crossDomain: true
    });

    // Empresa
    empresaDataManager = new ej.data.DataManager({
        url: '/Empresa/GetEmpresasCpd',
        adaptor: new ej.data.UrlAdaptor(),
        crossDomain: true,
        offline: true
    });
    empresaDataManager.ready.then((e) => {
        if (typeof dropdownEmpresaObj !== 'undefined')
            dropdownEmpresaObj.enabled = true;
    });

    // Cfop
    cfopDataManager = new ej.data.DataManager({
        url: location.origin + '/api/Cfop/GetCfopByTipoAnalise',
        adaptor: new ej.data.UrlAdaptor(),
        crossDomain: true
    });

    // Estabelecimento
    var estabelecimentoDataManager = new ej.data.DataManager({
        url: '/Estabelecimento/GetEstabelecimentosCpd',
        adaptor: new ej.data.UrlAdaptor(),
        crossDomain: true
    });

    var grid = new ej.grids.Grid({
        gridLines: 'Both',
        height: '300px',
        dataSource: dataManager,
        editSettings: { allowEditing: true, allowEditOnDblClick: false, allowAdding: true, allowDeleting: true, showDeleteConfirmDialog: true, mode: 'Dialog', template: '#dialogtemplate' },
        showColumnChooser: true,
        allowPaging: true,
        allowSorting: true,
        allowResizing: true,
        allowGrouping: false,
        allowTextWrap: true,
        actionFailure: gridFailure,
        owSelected: onRowSelected,
        filterSettings: { type: 'Menu' },
        pageSettings: {
            pageSize: 50,
            pageSizes: [10, 30, 50, 100, 1000, 5000, 10000]
        },
        toolbar:
            [
                'Add', 'Edit', 'Delete', 'Search',
                { text: 'Reprocessar', tooltipText: 'Reprocessar', prefixIcon: 'e-reload', id: 'Grid_reprocessar' },
                { text: 'Visualizar Processamento', tooltipText: 'Visualizar Processamento', prefixIcon: 'e-search', id: 'Grid_visualizarprocessamento' }
            ],
        toolbarClick: clickHandler,
        searchSettings: { fields: ['descricao', 'empresaNome'] },
        sortSettings: {
            columns: [
                { field: 'id', direction: 'desc' }
            ]
        },
        columns: [
            { field: 'id', headerText: '#', width: '50px', isPrimaryKey: true, isIdentity: true, allowSorting: false },
            { field: 'descricao', headerText: 'Descrição', allowSorting: false, template: '#templatedescricao' },
            { field: 'empresaNome', headerText: 'Empresa', width: '250px', allowSorting: false },
            { headerText: 'Entradas', width: '70px', allowSorting: false, template: '${dataInicioEntradasFormatado} \\n ${dataFimEntradasFormatado}' },
            { headerText: 'Saídas', width: '70px', allowSorting: false, template: '${dataInicioSaidasFormatado} \\n ${dataFimSaidasFormatado}' },
            { field: 'desconsiderarDrawbackSuspensao', headerText: 'Retirar Drawback Suspensão', width: '100px', template: '#templatedesconsiderarDrawbackSuspensao', textAlign: 'center', allowSorting: false },
            { field: 'processamentoId', headerText: 'Processamento', width: '130px', allowSorting: false },
            { field: 'iconStatus', headerText: 'Status', width: '150px', template: '#templateiconStatus', allowSorting: false }
        ],
        actionBegin: onGridActionBegin,
        actionComplete: function (args) {
            var isEdit = args.requestType === 'beginEdit';
            if ((args.requestType === 'beginEdit' || args.requestType === 'add')) {
                var data = args.rowData;

                //Dropdown Tipos de Análise
                dropdownTipoAnalise = new ej.dropdowns.DropDownList({
                    dataSource: tiposAnalise,
                    fields: { text: 'tipo', value: 'id' },
                    change: onDropdownTipoAnaliseChange,
                    enabled: !isEdit,
                    index: 0
                });
                dropdownTipoAnalise.appendTo('#tab-container_tab1_dropTipoAnalise');
                if (isEdit) {
                    var index = tiposAnalise.findIndex(function (tipoAnalise) {
                        return tipoAnalise.id == data.eTipoAnalise;
                    });
                    dropdownTipoAnalise.index = index;
                }

                //Dropdown CFOPS
                dropdownCfop = new ej.dropdowns.DropDownList({
                    dataSource: cfopDataManager,
                    placeholder: 'Cfops para o tipo de análise',
                    fields: { groupBy: 'grupo', text: 'codigo', value: 'id' },
                    itemTemplate: '${codigo} - ${descricao}',
                    actionBegin: onDropdownCfop_ActionBegin
                });
                dropdownCfop.appendTo('#tab-container_tab2_dropCfop');

                // Tabs
                tabObj = new ej.navigations.Tab({
                    items: [
                        { header: { 'text': 'Dados' }, content: '#tab-container_tab1' },
                        { header: { 'text': 'CFOP' }, content: '#tab-container_tab2' },
                        { header: { 'text': 'CNPJs' }, content: '#tab-container_tab3', disabled: true }
                    ]
                });
                tabObj.appendTo('#tab-container');

                // Auto-Complete CNPJ
                autocompleteCnpj = new ej.dropdowns.AutoComplete({
                    change: autocompleteInput,
                    placeholder: 'e.g. CNPJ',
                    enabled: !isEdit
                });
                autocompleteCnpj.appendTo('#tab-container_tab3_autocompleteCnpj_id');

                addButton = new ej.buttons.Button({ cssClass: 'e-info', disabled: true });
                addButton.appendTo('#tab-container_tab3_adicionar');

                removeButton = new ej.buttons.Button({ cssClass: 'e-danger', disabled: true });
                removeButton.appendTo('#tab-container_tab3_remover');

                dropdownPart = new ej.dropdowns.MultiSelect({
                    fields: { text: 'Descricao', value: 'Cnpj' },
                    mode: 'CheckBox'
                });
                dropdownPart.appendTo('#CnpjParticipantes');

                //Validator que é aplicado no form inteiro, porém está sendo criado especificamente para o listbox.
                var options = {
                    customPlacement: (inputElement, error) => {
                        document.getElementById('cnpjParticipanteError').appendChild(error);
                    },
                    validationComplete: (emit) => {
                        if (emit.inputName == "CnpjParticipantes" && emit.status == "failure") {
                            isListBoxValid = false;
                        } else {
                            isListBoxValid = true;
                        }
                    }
                };
                formObject = new ej.inputs.FormValidator('#GridEditForm', options);

                $(document).ready(function () {
                    var source = [];
                    $("#jqxWidget").jqxListBox({ selectedIndex: 3, source: source, width: 250, height: 300 });

                    if (isEdit) {
                        var cnpjParticipantes = data.cnpjParticipantes;
                        if (cnpjParticipantes.lenght !== 0) {
                            for (var i = 0; i < cnpjParticipantes.length; i++) {
                                var cnpjText = cnpjParticipantes[0].replace(/^(\d{2})(\d{3})?(\d{3})?(\d{4})?(\d{2})?/, "$1.$2.$3/$4-$5");
                                var item = { label: cnpjText, value: cnpjParticipantes[0] };
                                $("#jqxWidget").jqxListBox('addItem', item);
                            }
                        }
                        $('#jqxWidget').jqxListBox({ disabled: true });
                    }

                    var cnpjsParticipantesRequest = new ej.base.Ajax('/api/Analise/GetAnaliseParticipantesCnpjs', 'GET', true);
                    cnpjsParticipantesRequest.send().then();
                    cnpjsParticipantesRequest.onSuccess = function (data) {
                        var parsed = JSON.parse(data);
                        parsed.forEach(function (el) {
                            var cnpjText = el.replace(/^(\d{2})(\d{3})?(\d{3})?(\d{4})?(\d{2})?/, "$1.$2.$3/$4-$5");
                            var item = { label: cnpjText, value: el };
                            $("#jqxWidget").jqxListBox('addItem', item);
                        });
                    }

                    $('#jqxWidget').on('change', function (event) {
                        $("#tab-container_tab3_remover").prop('disabled', false);
                    });

                });

                // Convert Widget for the DataInicio field
                dtPickerInicio = new ej.calendars.DatePicker({
                    value: data.dataInicioEntradas,
                    max: moment().endOf('month')._d,
                    start: 'Year',
                    depth: 'Year',
                    format: 'MM/yyyy',
                    change: function (args) {
                        refreshDateRanges();
                    },
                    enabled: !isEdit
                }, args.form.elements.namedItem('f_datainicio'));

                // Convert Widget for the DataInicio field
                dtPickerInicioSaida = new ej.calendars.DatePicker({
                    value: data.dataInicioSaidas,
                    max: moment().endOf('month')._d,
                    start: 'Year',
                    depth: 'Year',
                    format: 'MM/yyyy',
                    change: function (args) {
                        refreshDateRanges();
                    },
                    enabled: !isEdit
                }, args.form.elements.namedItem('f_datainicio_saida'));

                // Convert Widget for the DataFim field
                dtPickerFim = new ej.calendars.DatePicker({
                    value: data.dataFimEntradas,
                    max: moment().endOf('month')._d,
                    start: 'Year',
                    depth: 'Year',
                    format: 'MM/yyyy',
                    change: function (args) {
                        refreshDateRanges();
                    },
                    enabled: !isEdit
                }, args.form.elements.namedItem('f_datafim'));

                dtPickerFimSaida = new ej.calendars.DatePicker({
                    value: data.dataFimSaidas,
                    max: moment().endOf('month')._d,
                    start: 'Year',
                    depth: 'Year',
                    format: 'MM/yyyy',
                    change: function (args) {
                        refreshDateRanges();
                    },
                    enabled: !isEdit
                }, args.form.elements.namedItem('f_datafim_saida'));

                dropdownEmpresaObj = new ej.dropdowns.DropDownList({
                    enabled: empresaDataManager.isDataAvailable,
                    dataSource: empresaDataManager,
                    fields: { text: 'nome', value: 'cnpj' },
                    filterBarPlaceholder: 'Pesquisar',
                    allowFiltering: true,
                    filtering: function (e) {
                        var query = new ej.data.Query();
                        if (e.text !== '') {
                            var predicate = new ej.data.Predicate('nome', 'startswith', e.text, true);
                            predicate = predicate.or('nome', 'contains', e.text, true);
                            query = query.where(predicate);
                        }
                        e.updateData(empresaDataManager, query);
                    },
                    change: function (empresa) {
                        dropdownObjEst.destroy();
                        dropdownObjDrop.destroy();
                        if (empresa.itemData != null) {
                            dropdownObjEst = new ej.dropdowns.MultiSelect({
                                dataSource: estabelecimentoDataManager,
                                query: new ej.data.Query().addParams('raizCnpj', empresa.itemData.cnpj),
                                fields: { text: 'descricao', value: 'cnpj' },
                                itemTemplate: '${cnpj} - ${descricao}',
                                mode: 'CheckBox',
                                showSelectAll: true,
                                showDropDownIcon: true,
                                filterBarPlaceholder: 'Pesquisar',
                                allowCustomValue: true,
                                change: function (estabObj) {
                                    dropdownObjDrop.destroy();
                                    if (estabObj.value != null &&
                                        estabObj.value.length > 0) {
                                        var dropDataManager = new ej.data.DataManager({
                                            url: '/api/Bom/GetDropsByCnpj',
                                            adaptor: new ej.data.UrlAdaptor(),
                                            crossDomain: true
                                        });
                                        dropdownObjDrop = new ej.dropdowns.DropDownList({
                                            dataSource: dropDataManager,
                                            query: new ej.data.Query().addParams('cnpj', estabObj.value[0]),
                                            fields: { text: 'nome', value: 'id' },
                                            filterBarPlaceholder: 'Pesquisar',
                                            allowFiltering: true,
                                            filtering: function (e) {
                                                var query = new ej.data.Query().select(['id', 'nome']);
                                                query = (e.text !== '') ? query.where('nome', 'startswith', e.text, true) : query;
                                                e.updateData(dropDataManager, query);
                                            }
                                        });
                                    } else {
                                        dropdownObjDrop = new ej.dropdowns.DropDownList({
                                            enabled: false
                                        });
                                    }
                                    dropdownObjDrop.appendTo('#DropName');
                                }
                            });
                        } else {
                            dropdownObjEst = new ej.dropdowns.MultiSelect({
                                enabled: false
                            });
                        }
                        dropdownObjDrop = new ej.dropdowns.DropDownList({
                            enabled: false
                        });
                        dropdownObjDrop.appendTo('#DropName');
                        dropdownObjEst.appendTo('#CnpjEstabelecimentos');
                    }
                });
                dropdownEmpresaObj.appendTo('#f_empresa');

                //--------------Carrega dropdown Estabelecimento------------
                dropdownObjEst = new ej.dropdowns.MultiSelect({
                    enabled: false
                });
                dropdownObjEst.appendTo('#CnpjEstabelecimentos');

                //----------Carrega dropdown DROP------------
                dropdownObjDrop = new ej.dropdowns.DropDownList({
                    enabled: false
                });
                dropdownObjDrop.appendTo('#DropName');

                // Set initail Focus
                if (args.requestType === 'beginEdit') {
                    $(".containerNovo").hide();
                    $(".containerEdit").show();
                    args.form.elements.namedItem('f_desconsiderardrawbacksuspencao').focus();
                } else {
                    $(".containerNovo").show();
                    $(".containerEdit").hide();
                    args.form.elements.namedItem('f_descricao').focus();
                }

                //Header Modal
                args.dialog.header = args.requestType === 'beginEdit' ? 'Editar análise' : 'Adicionar Nova análise';

                renderDateSliderEntrada();
                renderDateSliderSaida();

                refreshDateRanges();
            }

            if (args.requestType === 'cancel') {
                dropdownEmpresaObj.destroy();
                dropdownObjEst.destroy();
                dropdownObjDrop.destroy();
            }
        },
    });
    grid.appendTo('#Grid');

    function onGridActionBegin(args) {
        if (args.requestType == "sorting") {
            ga('send', 'event', 'Sort', 'Analise_Grid', columnName.toString());
        }
        if (args.requestType == "searching") {
            ga('send', 'event', 'Search_Input', 'Analise_Grid_Toolbar', args.searchString);
        }
        if (args.requestType == "paging") {
            ga('send', 'event', 'Paging', 'Analise_Grid', 'Pagination');
        }

        if (args.requestType == "save") {
            if (formObject.validate()) {
                if (dropdownTipoAnalise.value == 2 || dropdownTipoAnalise.value == 3) {

                    args.data.CnpjParticipantes = dropdownPart.value.map(x => x.replace(/[^\d]+/g, ''));

                }
                args.data.CnpjEstabelecimentos = dropdownObjEst.value;
                args.data.ETipoAnalise = dropdownTipoAnalise.value;
            }
            args.cancel = true;
        }
    }

    //-------------Mensagem de erro------------
    function gridFailure(args) {
        if (Array.isArray(args)) {
            obj = JSON.parse(args[0].error.response);
            App.Util.Mensagem("alerta", obj.Message);
        } else {
            obj = args.error.message;
            App.Util.Mensagem("alerta", obj);
        }
    }

    //-----------Atualiza o visualizador do processo-----------
    $('.atualizarprocessamento').click(function () {
        window.VisualizarProcessamento($("#codigoprocessamento").val());
    });

    //----------------Cria Modal Nenhum registro------------------------
    dialogObj = new ej.popups.Dialog({
        width: '320px',
        target: document.getElementById('gridAlert'),
        animationSettings: { effect: 'none' },
        isModal: true,
        buttons: [{
            click: dlgButtonClick,
            buttonModel: { content: 'Confirmar', isPrimary: true }
        }],
        created: dlgButtonClick
    });
    function dlgButtonClick() {
        dialogObj.hide();
    }
    dialogObj.appendTo('#gridAlert_dialog-content');

    //------------------------------------------
    function clickHandler(args) {
        if (args.item.id === 'Grid_add') {
            ga('send', 'event', 'Add_Record', 'Analise_Grid_Toolbar', 'Add');
        }
        if (args.item.id === 'Grid_edit') {
            ga('send', 'event', 'Edit_Record', 'Analise_Grid_Toolbar', 'Edit');
        }
        if (args.item.id === 'Grid_update') {
            ga('send', 'event', 'Update_Record', 'Analise_Grid_Toolbar', 'Update');
        }
        if (args.item.id === 'Grid_delete') {
            ga('send', 'event', 'Delete_Record', 'Analise_Grid_Toolbar', 'Delete');
        }
        if (args.item.id === 'Grid_cancel') {
            ga('send', 'event', 'Cancel_Record', 'Analise_Grid_Toolbar', 'Cancel');
        }
        if (args.item.id === 'Grid_search') {
            ga('send', 'event', 'Search_Record', 'Analise_Grid_Toolbar', 'Search');
        }

        var selectedrecords = grid.getSelectedRecords();
        //-----------Nenhum registro---------------------
        if (selectedrecords.length == 0) {
            if (args.item.id === 'Grid_reprocessar' || args.item.id === "Grid_visualizarprocessamento") {
                dialogObj.content = 'Não existem registros selecionados';
                dialogObj.buttons =
                    [{
                        click: dlgButtonClick,
                        buttonModel: { content: 'Confirmar', isPrimary: true }
                    }];
                dialogObj.show();
            }
        } else {
            //--------------Confirmação Reprocessar------------------
            if (args.item.id === 'Grid_reprocessar') {
                dialogObj.content = 'Tem certeza que deseja reprocessar o processamento selecionado?';
                dialogObj.buttons =
                    [
                        { 'click': () => { Reprocessar(selectedrecords[0].id) }, buttonModel: { content: 'Confirmar', cssClass: 'e-flat', isPrimary: true } },
                        { 'click': () => { dialogObj.hide(); }, buttonModel: { content: 'Cancelar', cssClass: 'e-flat' } }
                    ];
                dialogObj.show();
            }
            //----------------Visualizar Processamento----------------
            if (args.item.id === "Grid_visualizarprocessamento") {
                if (selectedrecords[0].processamentoId == null) {
                    dialogObj.content = 'Nenhum processamento encontrado para a Análise selecionada';
                    dialogObj.buttons =
                        [{
                            click: dlgButtonClick,
                            buttonModel: { content: 'Fechar', isPrimary: true }
                        }];
                    dialogObj.show();
                }
                else
                    VisualizarProcessamento(selectedrecords[0].processamentoId);
            }
        }
    };

    //-----------------Evento Reprocessamento------------
    function Reprocessar(id) {
        App.Util.Ajax("../Webservice/Pegasus.asmx/ReprocessarAnalise", { id: id }, function () {
            grid.refresh();
        }, function (error) {
            if (App.Util.IsJsonString(error)) {
                error = JSON.parse(error);
                App.Util.Mensagem("alerta", error.Message);
            }
            else
                App.Util.Mensagem("alerta", error);
        });
        dialogObj.hide();
    }

    //-----------------Evento Seleção de Linha------------
    function onRowSelected(args) {
        ga('send', 'event', 'Select_Grid_Record', 'FatorDeConversao_Grid_Select', 'Seleção na Grid');
    }

    //-----------------------Filtro--------------------
    $("#Grid_searchbar").on('keydown', function (event) {
        // Number 13 is the "Enter" key on the keyboard
        if (event.keyCode === 13) {
            // Cancel the default action, if needed
            event.preventDefault();
            //Filtra
            Grid_searchbutton.click();
        }
    });

    class DateRangeSlider extends ej.inputs.Slider {
        get formattedValue() {
            return [
                new Date(this.value[0]).format('MM/yyyy'),
                new Date(this.value[1]).format('MM/yyyy')
            ];
        }
        constructor(minDatePickerObj, maxDatePickerObj, options, element) {
            super(options, element);

            this.type = 'Range';
            this.minDatePicker = minDatePickerObj;
            this.maxDatePicker = maxDatePickerObj;

            this.min = moment().startOf('year').valueOf();
            this.max = moment().endOf('month').valueOf();

            var _this = this;
            this.minDatePicker.addEventListener('change',
                function (args) {
                    if (args.value.getTime() < _this.min)
                        _this.min = args.value.getTime();
                    _this.value = [args.value.getTime(), _this.value[1]];
                });

            this.maxDatePicker.addEventListener('change',
                function (args) {
                    _this.value = [_this.value[0], args.value.getTime()];
                });
        }

        appendTo(element) {
            this.value = [this.min, this.max];

            if (this.minDatePicker.value != null) {
                this.min = this.value[0] = this.minDatePicker.value.getTime();
            }

            if (this.maxDatePicker.value != null)
                this.max = this.value[1] = this.maxDatePicker.value.getTime();

            super.appendTo(element);
        }
    }

    function renderDateSliderEntrada() {

        // Initialize slider component
        dateEntradaSliderObj = new DateRangeSlider(dtPickerInicio, dtPickerFim, {
            readonly: true
        });
        // Render initialized Slider
        dateEntradaSliderObj.appendTo('#sliderEntrada');
    }

    function renderDateSliderSaida() {
        // Initialize slider component
        dateSaidaSliderObj = new DateRangeSlider(dtPickerInicioSaida, dtPickerFimSaida, {
            readonly: true
        });
        // Render initialized Slider
        dateSaidaSliderObj.appendTo('#sliderSaida');
    }

    function refreshDateRanges() {
        var minRange = dateEntradaSliderObj.min;
        if (dtPickerInicio.value != null)
            minRange = dtPickerInicio.value.getTime();

        if (dtPickerInicioSaida.value != null &&
            dtPickerInicio.value != null &&
            dtPickerInicioSaida.value < dtPickerInicio.value) {
            minRange = dtPickerInicioSaida.value.getTime();
        }
        dateEntradaSliderObj.min = dateSaidaSliderObj.min = minRange;

        var maxRange = dateEntradaSliderObj.max;
        if (dtPickerFim.value != null)
            maxRange = dtPickerFim.value.getTime();

        if (dtPickerFimSaida.value != null &&
            dtPickerFim.value != null &&
            dtPickerFimSaida.value > dtPickerFim.value) {
            maxRange = dtPickerFimSaida.value.getTime();
        }

        dateEntradaSliderObj.max = dateSaidaSliderObj.max = maxRange;

        loadDateRangeLabel();
    }

    function loadDateRangeLabel() {
        $('#lblDateRangeMin').val(new Date(dateEntradaSliderObj.min).format('MM/yyyy'));
        $('#lblDateRangeMax').val(new Date(dateEntradaSliderObj.max).format('MM/yyyy'));
    }

    //---------Carrega o grid do processamento-------------
    function VisualizarProcessamento(id) {
        $("#codigoprocessamento").val(id);
        App.Util.Ajax("../WebService/Pegasus.asmx/GetProcessamentos", { processamentoID: id }, function (processo) {
            $('#statusprocesso').html(processo.StatusProcess);
            $('#tbody').html("");
            for (var i = 0; i < processo.DetalhesProcessamento.length; i++) {
                if (processo.DetalhesProcessamento[i].DesStatus == null) {
                    $('#tbody').append("<tr><td colspan='2'>" + "Nenhum registro encontrado" + "</td></tr>");
                } else {
                    $('#tbody').append("<tr style='color: " + processo.DetalhesProcessamento[i].Color + ";'><td>" + processo.DetalhesProcessamento[i].DesStatus + "</td><td>" + processo.DetalhesProcessamento[i].FormatDataProcess + "</td></tr>");
                }
            }
            $("#modal-processamento").modal("show");
        });
    }

    //----------------Evento mundança tipo de análise--------------
    function onDropdownTipoAnaliseChange(e) {
        switch (e.value) {
            case '1':
            case '4':
                tabObj.enableTab(2, false);
                formObject.removeRules('CnpjParticipantes', { required: [true, 'Insira no mínimo 1 CNPJ!.'] });
                break;
            case '2':
            case '3':
                tabObj.enableTab(2, true);
                formObject.addRules('CnpjParticipantes', { required: [true, 'Insira no mínimo 1 CNPJ!.'] });
                break;
        }

        dropdownCfop.destroy();
        var newQuery = new ej.data.Query().addParams('valorTipoAnalise', e.value);
        dropdownCfop = new ej.dropdowns.DropDownList({
            dataSource: cfopDataManager,
            query: newQuery,
            fields: { groupBy: 'grupo', text: 'codigo', value: 'id' },
            itemTemplate: '${codigo} - ${descricao}',
        });
        dropdownCfop.appendTo('#tab-container_tab2_dropCfop');
    }

    //-------------------Evento listagem dropdown CFOP----------------
    function onDropdownCfop_ActionBegin(e) {
        e.query = new ej.data.Query().addParams("valorTipoAnalise", dropdownTipoAnalise.value);
    }


    $(".tab-container_tab3_autocompleteCpnj").mask('00.000.000/0000-00');

    $("#btnAtualizarStatus").on('click', function (e) {
        ga('send', 'event', 'Modal_Actions', 'Alias_Update_Modal_Form', 'Atualizar');
    });

    $("#dismissModal").on('click', function (e) {
        ga('send', 'event', 'Modal_Actions', 'Analise_Close_Modal_Form', 'Fechar');
    });

    $("#dismissModalFooter").on('click', function (e) {
        ga('send', 'event', 'Modal_Actions', 'Analise_Close_Modal_Form', 'Fechar');
    });

    $("#f_descricao").on('focus', function (e) {
        ga('send', 'event', 'Modal_Actions', 'Analise_Show_Modal', 'Descrição');
    });

    $("#f_datainicio").on('focus', function (e) {
        ga('send', 'event', 'Input_Data', 'Analise_Input_Data_Inicio', 'Data Início');
    });

    $("#f_datafim").on('focus', function (e) {
        ga('send', 'event', 'Input_Data', 'Analise_Input_Data_Fim', 'Data Fim');
    });
    $("#f_desconsiderardrawbacksuspencao").on('change', function (e) {
        ga('send', 'event', 'Input_Data', 'Analise_Input_Drawback_Suspensao', 'Drawback Suspensao');
    });

    $("#f_desconsiderarcompranacional").on('change', function (e) {
        ga('send', 'event', 'Input_Data', 'Analise_Input_Compra_Nacional', 'Desconsiderar Compra Nacional');
    });

    $("#f_empresa").on('focus', function (e) {
        ga('send', 'event', 'Input_Data', 'Analise_Input_Empresa', 'Empresa');
    });

    $("#f_empresaedit").on('focus', function (e) {
        ga('send', 'event', 'Input_Data', 'Analise_Input_Empresa_Edit', 'Empresa');
    });

    //$("#f_estabelecimentoedit").on('focus', function (e) {
    //    ga('send', 'event', 'Input_Data', 'Analise_Input_Estabelecimento_edit', 'Estabelecimento Edit');
    //});

    $("#f_estabelecimentohide").on('focus', function (e) {
        ga('send', 'event', 'Input_Data', 'Analise_Input_Estabelecimento_Hide', 'Estabelecimento Hide');
    });

    $("#f_dropedit").on('focus', function (e) {
        ga('send', 'event', 'Input_Data', 'Analise_Input_Drop_Edit', 'Drop Edit');
    });

    window.VisualizarProcessamento = VisualizarProcessamento;
})();



function addCnpj() {
    var cnpj = $('#tab-container_tab3_autocompleteCnpj_id').val();
    $("#jqxWidget").jqxListBox('addItem', cnpj);
    dropdownPart.addItem({ Descricao: "Descricao", Cnpj: cnpj });
    dropdownPart.selectAll(true);
    $("#tab-container_tab3_autocompleteCnpj_id").val("");
    $("#tab-container_tab3_adicionar").prop('disabled', true);
    return false;
}

function removeCnpj() {
    $("#jqxWidget").jqxListBox("removeAt", $("#jqxWidget").jqxListBox("getSelectedIndex"));
    $("#tab-container_tab3_remover").prop('disabled', true);
    return false;
}

$("#container_tab3_remover").on('click', function (e) {
    
});

function autocompleteInput() {
    var cnpj = $("#tab-container_tab3_autocompleteCnpj_id").val();
    if (cnpj.length <= 15) {
        $("#tab-container_tab3_adicionar").prop('disabled', true);
    } else {
        $("#tab-container_tab3_adicionar").prop('disabled', false);
    }
}


